[Java](https://go.java/index.html) is among the most popular available programming languages, thanks to its versatility and compatibility. 
It is widely used for software development, mobile applications and developing larger systems.

Java was born in 1995 and is maintained by [Oracle](https://www.oracle.com/index.html). 
Despite the fact that it isn't as young as some of the fresh languages out there, Java is still really popular. 
It was designed to be fast, secure, reliable, beginner-friendly and highly portable. 
This portability perk exists because Java is executed on a cross-platform compatible [Java Virtual Machine - JVM](https://en.wikipedia.org/wiki/Java_virtual_machine). 
Android apps are also developed using Java, since the [Android Operating System](https://en.wikipedia.org/wiki/Android_(operating_system)) runs on a Java language environment.

The Java community is huge!
GitHub for example has over 1.5 million Java projects. 
It's also worth mentioning that Java has the second largest community in [StackOverflow](https://stackoverflow.com/questions/tagged/java)! 
This is important because the larger a programming language community is, the more support you'd be likely to get.

Java also has a powerful and well-designed set of built-in [APIs - Application Programming Interfaces](https://docs.oracle.com/javase/8/docs/api/), which can be used for various activities like Database connection, networking, I/O, XML parsing, utilities, and much more.

From laptops to datacenters, game consoles to scientific supercomputers, cell phones to the Internet, [Java is everywhere](https://en.wikipedia.org/wiki/Write_once,_run_anywhere)!
